Skip to content

# File

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the file helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `FileHelper`

Simplify the file manipulations.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`path` | `str` | The file path to work with. | `None`

Source code in `PyFunceble/helpers/file.py`

     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226

    class FileHelper:
        """
        Simplify the file manipulations.

        :param str path: The file path to work with.
        """

        _path: Optional[str] = None

        def __init__(self, path: Optional[str] = None):
            if path:
                self.path = path

        @property
        def path(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_path` attribute.
            """

            return self._path

        @path.setter
        def path(self, value: str) -> None:
            """
            Sets the path to work with.

            :param value:
                The path to work with.

            :raise TypeError:
                When :code:`value` is a :py:class:`value`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} is given.")

            self._path = value

        def set_path(self, value: str) -> "FileHelper":
            """
            Sets the path to work with.

            :param value:
                The path to work with.
            """

            self.path = value

            return self

        def join_path(self, *args) -> str:
            """
            Joins the given arguments with the given path.
            """

            return os.path.join(self.path, *args)

        def exists(self) -> bool:
            """
            Checks if the given file path exists.
            """

            return os.path.isfile(self.path)

        def get_size(self) -> int:
            """
            Provides the size (in bytes) of the
            given file path.
            """

            return os.stat(self.path).st_size

        def is_empty(self) -> bool:
            """
            Checks if the given file path is empty.
            """

            return self.get_size() <= 0

        def delete(self) -> "FileHelper":
            """
            Deletes the given file path if it exists.
            """

            if self.exists():
                os.remove(self.path)
            return self

        def write(
            self, data: Any, *, overwrite: bool = False, encoding: str = "utf-8"
        ) -> "FileHelper":
            """
            Write the given data into the given file path.

            :param data: The data to write.
            :param encoding: The encoding to use while opening the file.
            """

            if overwrite or not self.exists():
                DirectoryHelper(os.path.dirname(self.path)).create()

                with self.open("w", encoding=encoding) as file_stream:
                    file_stream.write(data)
            else:
                with self.open("a", encoding=encoding) as file_stream:
                    file_stream.write(data)

            return self

        def read(self, *, encoding: str = "utf-8") -> Optional[str]:
            """
            Read the given file path and return it's content.

            :param str encoding: The encoding to use.
            """

            data = None

            if self.exists():
                with self.open("r", encoding=encoding) as file_stream:
                    data = file_stream.read()

            return data

        def read_bytes(self) -> Optional[bytes]:
            """
            Read the given file ath and returns it's bytes contetn.
            """

            data = None

            if self.exists():
                with self.open("rb") as file_stream:
                    data = file_stream.read()

            return data

        def open(self, *args, **kwargs) -> "open":
            """
            A wrapper for the built-in :py:class:`open` function.
            """

            return open(self.path, *args, **kwargs)  # pylint: disable=unspecified-encoding

        def copy(self, destination: str) -> "FileHelper":
            """
            Copy the globaly given file path to the given destination.

            :param str destination: The destination of the copy.
            """

            if self.exists():
                shutil.copy(self.path, destination)

            return self

        def move(self, destination) -> "FileHelper":
            """
            Move the globally given file path to the given destination.

            :param str destination: The destination of the file.
            """

            if self.exists():
                shutil.move(self.path, destination)

            return self

### `path: Optional[str]` `property` `writable`

Provides the current state of the :code:`_path` attribute.

### `copy(destination)`

Copy the globaly given file path to the given destination.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`destination` | `str` | The destination of the copy. | required

Source code in `PyFunceble/helpers/file.py`

    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214

    def copy(self, destination: str) -> "FileHelper":
        """
        Copy the globaly given file path to the given destination.

        :param str destination: The destination of the copy.
        """

        if self.exists():
            shutil.copy(self.path, destination)

        return self

### `delete()`

Deletes the given file path if it exists.

Source code in `PyFunceble/helpers/file.py`

    139
    140
    141
    142
    143
    144
    145
    146

    def delete(self) -> "FileHelper":
        """
        Deletes the given file path if it exists.
        """

        if self.exists():
            os.remove(self.path)
        return self

### `exists()`

Checks if the given file path exists.

Source code in `PyFunceble/helpers/file.py`

    117
    118
    119
    120
    121
    122

    def exists(self) -> bool:
        """
        Checks if the given file path exists.
        """

        return os.path.isfile(self.path)

### `get_size()`

Provides the size (in bytes) of the given file path.

Source code in `PyFunceble/helpers/file.py`

    124
    125
    126
    127
    128
    129
    130

    def get_size(self) -> int:
        """
        Provides the size (in bytes) of the
        given file path.
        """

        return os.stat(self.path).st_size

### `is_empty()`

Checks if the given file path is empty.

Source code in `PyFunceble/helpers/file.py`

    132
    133
    134
    135
    136
    137

    def is_empty(self) -> bool:
        """
        Checks if the given file path is empty.
        """

        return self.get_size() <= 0

### `join_path(*args)`

Joins the given arguments with the given path.

Source code in `PyFunceble/helpers/file.py`

    110
    111
    112
    113
    114
    115

    def join_path(self, *args) -> str:
        """
        Joins the given arguments with the given path.
        """

        return os.path.join(self.path, *args)

### `move(destination)`

Move the globally given file path to the given destination.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`destination` | `str` | The destination of the file. | required

Source code in `PyFunceble/helpers/file.py`

    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226

    def move(self, destination) -> "FileHelper":
        """
        Move the globally given file path to the given destination.

        :param str destination: The destination of the file.
        """

        if self.exists():
            shutil.move(self.path, destination)

        return self

### `open(*args, **kwargs)`

A wrapper for the built-in class:`open` function.

Source code in `PyFunceble/helpers/file.py`

    197
    198
    199
    200
    201
    202

    def open(self, *args, **kwargs) -> "open":
        """
        A wrapper for the built-in :py:class:`open` function.
        """

        return open(self.path, *args, **kwargs)  # pylint: disable=unspecified-encoding

### `read(*, encoding='utf-8')`

Read the given file path and return it's content.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`encoding` | `str` | The encoding to use. | `'utf-8'`

Source code in `PyFunceble/helpers/file.py`

    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182

    def read(self, *, encoding: str = "utf-8") -> Optional[str]:
        """
        Read the given file path and return it's content.

        :param str encoding: The encoding to use.
        """

        data = None

        if self.exists():
            with self.open("r", encoding=encoding) as file_stream:
                data = file_stream.read()

        return data

### `read_bytes()`

Read the given file ath and returns it's bytes contetn.

Source code in `PyFunceble/helpers/file.py`

    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195

    def read_bytes(self) -> Optional[bytes]:
        """
        Read the given file ath and returns it's bytes contetn.
        """

        data = None

        if self.exists():
            with self.open("rb") as file_stream:
                data = file_stream.read()

        return data

### `set_path(value)`

Sets the path to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The path to work with. | required

Source code in `PyFunceble/helpers/file.py`

     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108

    def set_path(self, value: str) -> "FileHelper":
        """
        Sets the path to work with.

        :param value:
            The path to work with.
        """

        self.path = value

        return self

### `write(data, *, overwrite=False, encoding='utf-8')`

Write the given data into the given file path.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`data` | `Any` | The data to write. | required
`encoding` | `str` | The encoding to use while opening the file. | `'utf-8'`

Source code in `PyFunceble/helpers/file.py`

    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167

    def write(
        self, data: Any, *, overwrite: bool = False, encoding: str = "utf-8"
    ) -> "FileHelper":
        """
        Write the given data into the given file path.

        :param data: The data to write.
        :param encoding: The encoding to use while opening the file.
        """

        if overwrite or not self.exists():
            DirectoryHelper(os.path.dirname(self.path)).create()

            with self.open("w", encoding=encoding) as file_stream:
                file_stream.write(data)
        else:
            with self.open("a", encoding=encoding) as file_stream:
                file_stream.write(data)

        return self